//
//  NSBundle+SMCodeSigning.h
//  InterfaceInspector
//
//  Created by Stephan Michels on 05.08.13.
//  Copyright (c) 2013 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>

// original code from https://github.com/ole/NSBundle-OBCodeSigningInfo

typedef NS_ENUM(NSUInteger, SMCodeSignState) {
    SMCodeSignStateUnsigned = 1,
    SMCodeSignStateSignatureValid,
    SMCodeSignStateSignatureInvalid,
    SMCodeSignStateSignatureNotVerifiable,
    SMCodeSignStateSignatureUnsupported,
    SMCodeSignStateError
};

@interface NSBundle (SMCodeSigning)

@property (nonatomic, readonly, getter = isComingFromAppStore) BOOL comingFromAppStore;
@property (nonatomic, readonly, getter = isSandboxed) BOOL sandboxed;
@property (nonatomic, readonly) SMCodeSignState codeSignState;
@property (nonatomic, readonly) NSDictionary *codeSigningInformation;

@end
