//
//  SMDelayedInvocation.h
//  SMInspectorKit
//
//  Created by Stephan Michels on 06.12.12.
//  Copyright (c) 2012 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMCancellable.h"

@interface SMDelayedInvocation : NSObject <SMCancellable>

@property (nonatomic, weak) NSRunLoop *runLoop;
@property (nonatomic, copy) NSArray *runLoopModes;
@property (nonatomic, copy) NSNumber *delay;
@property (nonatomic, copy) NSNumber *priority;
@property (nonatomic, getter=isScheduled, readonly) BOOL scheduled;
@property (nonatomic, getter=isFinished, readonly) BOOL finished;
@property (nonatomic, getter=isPending, readonly) BOOL pending;

+ (instancetype)delayedInvocationWithBlock:(void(^)(void))block;
+ (instancetype)scheduleDelayedInvocationWithBlock:(void(^)(void))block;
+ (instancetype)delayedInvocationWithTarget:(id)target selector:(SEL)selector;

- (instancetype)initWithBlock:(void(^)(void))block;
- (void)schedule;

@end
