//
//  SMExpandableView.h
//  Drawings
//
//  Created by Stephan Michels on 13.10.11.
//  Copyright (c) 2011 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMVerticalStackView.h"

typedef NS_ENUM(NSUInteger, SMExpandableViewStyle) {
	SMExpandableViewStyleFat = 0,
	SMExpandableViewStyleFlat,
};

@protocol SMExpandableViewDelegate;

@interface SMExpandableView : SMView

@property (nonatomic) SMExpandableViewStyle style;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, strong, readonly) NSView *bodyView;
@property (nonatomic, getter=isExpanded) BOOL expanded;
@property (nonatomic, weak) id<SMExpandableViewDelegate> delegate;

- (id)initWithBodyView:(NSView *)bodyView;
- (id)initWithFrame:(NSRect)frame NS_UNAVAILABLE;
- (id)init NS_UNAVAILABLE;
+ (id)new NS_UNAVAILABLE;

@end

@protocol SMExpandableViewDelegate <NSObject>

-(void)expandableView:(SMExpandableView *)headerView didExpand:(BOOL)expanded;

@end