//
//  SMInspectorProperty.h
//  SMInspectorKit
//
//  Created by Stephan Michels on 09.11.12.
//  Copyright (c) 2012 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMViewController.h"


@interface SMInspectorProperty : SMViewController

@property (nonatomic, weak, readonly) id owner;

@property (nonatomic, copy) NSString *titleKeyPath;
@property (nonatomic, copy) NSString *keyPath;
@property (nonatomic, strong) NSValueTransformer *valueTransformer;
@property (nonatomic) BOOL enabled;
@property (nonatomic, copy) NSString *enabledKeyPath;
@property (nonatomic, strong) NSValueTransformer *enabledValueTransformer;
@property (nonatomic) SEL actionSelector;
@property (nonatomic, copy) NSString *actionName;

@property (nonatomic, readonly) NSView *viewForBaselineAlignment;
@property (nonatomic, readonly) CGFloat baselineOffsetFromView;

- (id)initWithOwner:(id)owner;
- (id)init NS_UNAVAILABLE;
+ (id)new NS_UNAVAILABLE;

- (void)prepareForReuse;
- (void)refresh;
- (IBAction)userDidChangeValue:(id)sender;

- (void)bindEnabledKeyPathToControl:(NSControl *)control;
//- (void)unbindEnabledKeyPathToControl:(NSControl *)control;
//- (void)unbindControl:(NSControl *)control;

- (id)reflectedValue;
- (void)setReflectedValue:(id)value;

- (NSArray *)representedObjectsForControllerSelectionKeyPath:(NSString *)keyPath;
- (NSString *)keyPathByStripingControllerSelectionPrefix:(NSString *)keyPath;
- (BOOL)keyPathHasControllerSelectionPrefix:(NSString *)keyPath;
- (NSString *)selectionControllerKeyPathFromKeyPath:(NSString *)keyPath;

- (BOOL)canTileIntoColumnsWithWidth:(double)width;
- (BOOL)canTileIntoColumnsWithProperty:(SMInspectorProperty *)property;


@end
