//
//  SMSnapUtilities.h
//  Drawings
//
//  Created by Stephan Michels on 23.01.12.
//  Copyright (c) 2012 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSUInteger, SMSnapMode)  {
    SMSnapModeFloor = 0,
    SMSnapModeCeil,
    SMSnapModeRound,
};

typedef NS_ENUM(NSUInteger, SMRectSnapMode)  {
    SMRectSnapModeInwards = 0,
    SMRectSnapModeOutwards,
    SMRectSnapModeNearst,
};


typedef CGPoint (^SMPointTransformBlock)(CGPoint point);
typedef CGSize (^SMSizeTransformBlock)(CGSize size);
typedef CGRect (^SMRectTransformBlock)(CGRect rect);


CGPoint SMTransformPointInDeviceSpace(CGContextRef context, CGPoint point, SMPointTransformBlock block);
CGSize SMTransformSizeInDeviceSpace(CGContextRef context, CGSize size, SMSizeTransformBlock block);
CGRect SMTransformRectInDeviceSpace(CGContextRef context, CGRect rect, SMRectTransformBlock block);

CGPoint SMSnapPoint(CGPoint point, SMSnapMode mode, BOOL halfPoints);
CGSize SMSnapSize(CGSize size, SMSnapMode mode, BOOL halfPoints);
CGRect SMSnapRect(CGRect rect, SMRectSnapMode mode, BOOL halfPoints);

CGPoint SMSnapPointInDeviceSpace(CGContextRef context, CGPoint point, SMSnapMode mode, BOOL halfPoints);
CGSize SMSnapSizeInDeviceSpace(CGContextRef context, CGSize  size, SMSnapMode mode, BOOL halfPoints);
CGRect SMSnapRectInDeviceSpace(CGContextRef context, CGRect rect, SMRectSnapMode mode, BOOL halfPoints);

@interface NSView (SMSnapUtilities)

- (CGPoint)transformPointInBacking:(CGPoint)point block:(SMPointTransformBlock)block;
- (CGSize)transformSizeInBacking:(CGSize)size block:(SMSizeTransformBlock)block;
- (CGRect)transformRectInBacking:(CGRect)rect block:(SMRectTransformBlock)block;

- (CGPoint)snapPointInBacking:(CGPoint)point mode:(SMSnapMode)mode halfPoints:(BOOL)halfPoints;
- (CGSize)snapSizeInBacking:(CGSize)size mode:(SMSnapMode)mode halfPoints:(BOOL)halfPoints;
- (CGRect)snapRectInBacking:(CGRect)rect mode:(SMRectSnapMode)mode halfPoints:(BOOL)halfPoints;

@end